#ifndef _MEMO_
#define _MEMO_
#include "WinList.h"

class THIMemo:public THIWinList
{
   private:
    static void _OnChange(void *ClassPointer,void *Param)
    {
      _hi_onEvent( _hie(THIMemo)->_event_onChange);
    }
   public:
    BYTE _prop_ScrollBars;
    bool _prop_ReadOnly;
    HI_STRING _prop_Strings;
    THIMemo(TWinControl *_Parent)
    {
      Control = new TMemo(_Parent,ES_AUTOVSCROLL|ES_AUTOHSCROLL);
      FList = ((TMemo*)Control)->Lines;
    }
    void Init();
    HI_WORK_LOC(THIMemo,_work_doInscribe){SendMessage(Control->Handle, WM_PASTE, 0,0);}    
    HI_WORK_LOC(THIMemo,_work_doSetSelect){ ((TMemo*)Control)->SelText = ToString(_Data); }
    HI_WORK_LOC(THIMemo,_work_doSetSelStart){Control->Focused();((TMemo*)Control)->SelStart = ToInteger(_Data); }
    HI_WORK_LOC(THIMemo,_work_doSetSelLength){Control->Focused();((TMemo*)Control)->SelLength = ToInteger(_Data); }
    HI_WORK_LOC(THIMemo,_var_SelText){ CreateData(_Data,((TMemo*)Control)->SelText); }
};

//######################################################################

int styl[4] = {0,WS_HSCROLL|ES_AUTOHSCROLL,WS_VSCROLL|ES_AUTOVSCROLL,WS_VSCROLL|WS_HSCROLL|ES_AUTOVSCROLL|ES_AUTOHSCROLL};

void THIMemo::Init()
{  
  ((TMemo *)Control)->Style = styl[_prop_ScrollBars];
  ((TMemo *)Control)->OnChange = DoNotifyEvent(this,_OnChange);
  THIWin::Init(); 
     if(_prop_Strings)       
          {HI_STRING rbuf;
         AtoU((char *)_prop_Strings,&rbuf);
         FList->Text = string(rbuf);
         delete rbuf;}       
}
#endif